//-----------------------------
//   AERO-RADIO
//        improving gnuradio!
//-----------------------------
#pragma once
#ifndef INCLUDED_AR_FSK_IMAGE_SINK_H
#define INCLUDED_AR_FSK_IMAGE_SINK_H

#include <gr_sync_block.h>
#include <omnithread.h>
#include <winsock.h>

#include "FSK_ImageProcessor.h"  

class ar_fsk_image_sink;
typedef boost::shared_ptr<ar_fsk_image_sink> ar_fsk_image_sink_sptr;

ar_fsk_image_sink_sptr ar_make_fsk_image_sink(size_t itemsize, const char *filename); //JR int flip sign
//ar_fsk_image_sink_sptr ar_make_fsk_image_sink(size_t itemsize, const char *filename, int use_socket_flag, FILE * BERFILE); //Backward Compatibility
ar_fsk_image_sink_sptr ar_make_fsk_image_sink(size_t itemsize, const char *filename, int use_socket_flag, char * BERFileName); //Backward Compatibility
/*!
 * \brief Write stream to file.
 * \ingroup sink
 */

class ar_fsk_image_sink : public gr_sync_block
{
  friend ar_fsk_image_sink_sptr ar_make_fsk_image_sink(size_t itemsize, const char *filename); //JR int flip sign
  //friend ar_fsk_image_sink_sptr ar_make_fsk_image_sink(size_t itemsize, const char *filename, int use_socket_flag, FILE * BERFILE);  //Backward Compatibility
  friend ar_fsk_image_sink_sptr ar_make_fsk_image_sink(size_t itemsize, const char *filename, int use_socket_flag, char * BERFileName);  //Backward Compatibility

 private:
  size_t	    d_itemsize;
  void	       *d_fp;		// current FILE pointer
  void	       *d_new_fp;	// new FILE pointer
  bool		    d_updated;	// is there a new FILE pointer?
  omni_mutex	d_mutex;
  
  int d_use_socket_flag;
  //FILE * d_BERFILE;
  char * d_BERFileName;

 protected:
    //ar_fsk_image_sink(size_t itemsize, const char *filename, int use_socket_flag, FILE * BERFILE); //JR int flip sign
     ar_fsk_image_sink(size_t itemsize, const char *filename, int use_socket_flag,  char * BERFileName); //JR int flip sign

 public:
  ~ar_fsk_image_sink();

  /*! 
   * \brief Open filename and begin output to it.
   */
  bool open(const char *filename);

  /*!
   * \brief Close current output file.
   *
   * Closes current output file and ignores any output until
   * open is called to connect to another file.
   */
  void close();

  int work(int noutput_items,
	   gr_vector_const_void_star &input_items,
	   gr_vector_void_star &output_items);
};


#endif /* INCLUDED_AR_FSK_IMAGE_SINK_H */
