// BitmapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BitmapDlg.h"
#include ".\bitmapdlg.h"

const UINT ID_EMWIN_TIMER = 0x1000;


// CBitmapDlg dialog

IMPLEMENT_DYNAMIC(CBitmapDlg, CDialog)
CBitmapDlg::CBitmapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBitmapDlg::IDD, pParent)
	, m_sEmwinSliderEcho(_T(""))
{
	m_bInitDialog = TRUE;
	m_EmwinImageLoop = NULL;
}

CBitmapDlg::~CBitmapDlg()
{
}

void CBitmapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDOK, m_ButtonOk);
	DDX_Control(pDX, IDC_SAVE_BITMAP_IMAGE, m_ButtonSaveBitmapImage);
	DDX_Control(pDX, IDC_BITMAP_DISPLAY, m_PictureControl);
	DDX_Control(pDX, IDC_EMWIN_SPEED, m_EmwinSlider);
	DDX_Text(pDX, IDC_EMWIN_SPEED_ECHO, m_sEmwinSliderEcho);
}

void CBitmapDlg::InitBitmapDisplay()
{
	CRect brect;
	GetDlgItem(IDC_BITMAP_DISPLAY)->GetWindowRect(brect);
	ScreenToClient(brect);
	m_bmpCtrl.Create(WS_CHILD|WS_VISIBLE, brect, this);

	m_bInitDialog = FALSE;
}


BEGIN_MESSAGE_MAP(CBitmapDlg, CDialog)
	ON_WM_SIZE()
//	ON_WM_SIZING()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_SAVE_BITMAP_IMAGE, OnBnClickedSaveBitmapImage)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_EMWIN_SPEED, OnNMReleasedcaptureEmwinSpeed)
END_MESSAGE_MAP()


// CBitmapDlg message handlers

void CBitmapDlg::OnBnClickedSaveBitmapImage()
{
	// TODO: Add your control notification handler code here
	StopEmwinTimer();

	if (!FileExists(m_sTempFilename))
	{
		AfxMessageBox("No image file to save!", MB_OK | MB_ICONEXCLAMATION);	
		return;
	}
	CString newfile, temp;
	newfile = m_sDblClickFilename;

	temp = newfile;
	temp.MakeLower();
	if (temp.Find("lrit") > -1)
		newfile = newfile.Left(newfile.GetLength() - 4);
	else
		newfile = newfile.Left(newfile.GetLength() - 3);

	newfile += "bmp";
	CFileDialog dlg(FALSE, "*.bmp", (LPCTSTR)newfile, OFN_HIDEREADONLY, "Bitmap Files (*.bmp)|*.bmp||", this);
	dlg.m_ofn.lpstrTitle = "Save Bitmap File";
	if(dlg.DoModal() == IDOK)
	{
		newfile = dlg.GetPathName();
		CopyFile((LPCTSTR)m_sTempFilename, (LPCTSTR)newfile, FALSE);
	}

	StartEmwinTimer(m_iTimerMilliseconds);
}

BOOL CBitmapDlg::FileExists(CString Infilename)
{
	CFileFind FileFinder;

	CString m_sTempstr = Infilename;

	m_sTempstr.MakeLower();
	if (FileFinder.FindFile(m_sTempstr, 0))
		return TRUE;
	else 
	{
		m_sTempstr.MakeUpper();
		if (FileFinder.FindFile(m_sTempstr, 0))
		    return TRUE;
	    else
		    return FALSE;
	} 
}

void CBitmapDlg::OnSize(UINT nType, int cx, int cy)
{
	CWnd::OnSize(nType, cx, cy);

	if (!m_bInitDialog && ((nType == SIZE_MAXIMIZED) || (nType == SIZE_RESTORED)))
	{
		CRect rect;
		GetDlgItem(IDC_BITMAP_DISPLAY)->GetWindowRect(rect);
		ScreenToClient(rect);
		rect.right = cx - 13;
		rect.bottom = cy - 45;
		
		m_PictureControl.MoveWindow(&rect);
		m_bmpCtrl.ResetBitmapCtrl();
		m_bmpCtrl.Create(WS_CHILD|WS_VISIBLE, rect, this);

		if (m_bDisplayLrit && FileExists(m_sTempFilename))
			m_bmpCtrl.LoadFile(m_sTempFilename);

		GetDlgItem(IDOK)->GetWindowRect(rect);
		ScreenToClient(rect);
		rect.right = cx - 11;
		rect.left = rect.right - 75;
		rect.bottom = cy - 11;
		rect.top = rect.bottom - 23;
		m_ButtonOk.MoveWindow(&rect);
		m_ButtonOk.Invalidate();

		GetDlgItem(IDC_SAVE_BITMAP_IMAGE)->GetWindowRect(rect);
		ScreenToClient(rect);
		rect.right = cx - 102;
		rect.left = rect.right - 75;
		rect.bottom = cy - 11;
		rect.top = rect.bottom - 23;
		m_ButtonSaveBitmapImage.MoveWindow(&rect);
		m_ButtonSaveBitmapImage.Invalidate();

		GetDlgItem(IDC_EMWIN_SPEED)->GetWindowRect(rect);
		ScreenToClient(rect);
		rect.right = cx - 203;
		rect.left = rect.right - 140;
		rect.bottom = cy - 14;
		rect.top = rect.bottom - 18;
		m_EmwinSlider.MoveWindow(&rect);
		m_EmwinSlider.Invalidate();

		GetDlgItem(IDC_EMWIN_SPEED_ECHO)->GetWindowRect(rect);
		ScreenToClient(rect);
		rect.right = cx - 343;
		rect.left = rect.right - 80;
		rect.bottom = cy - 9;
		rect.top = rect.bottom - 23;
		GetDlgItem(IDC_EMWIN_SPEED_ECHO)->MoveWindow(&rect);
		GetDlgItem(IDC_EMWIN_SPEED_ECHO)->Invalidate();
	}
}

void CBitmapDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	StopEmwinTimer();

	ShowWindow(SW_HIDE);
}

void CBitmapDlg::StartEmwinTimer(UINT milliseconds)
{
	SetTimer(ID_EMWIN_TIMER, milliseconds, 0);
}

void CBitmapDlg::StopEmwinTimer()
{
	KillTimer(ID_EMWIN_TIMER);
}

void CBitmapDlg::OnTimer(UINT nIDEvent)
{
	CString tempstr = "";

	if (nIDEvent == ID_EMWIN_TIMER)
	{
		m_EmwinImageLoop->counter = ++m_EmwinImageLoop->counter % m_EmwinImageLoop->image_count;

		tempstr = "";
		tempstr.Format("temp_emwin_%u.bmp", m_EmwinImageLoop->counter); 
		m_bmpCtrl.LoadFile(tempstr);

		m_sTempFilename = tempstr;
	}
}

void CBitmapDlg::OnNMReleasedcaptureEmwinSpeed(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	UINT actual_value, step = EMWIN_LOOP_MIN_DELAY;

	*pResult = 0;

	actual_value = m_EmwinSlider.GetPos();

	while (step < actual_value)
		step += 250;
	if ((step - actual_value) < (actual_value - step + 250))
		m_iTimerMilliseconds = step;
	else
		m_iTimerMilliseconds = step - 250;

	StopEmwinTimer();

	m_EmwinSlider.SetPos(m_iTimerMilliseconds);

	if (m_iTimerMilliseconds < EMWIN_LOOP_MAX_DELAY)
	{
		m_sEmwinSliderEcho.Format("Delay: %d ms", m_iTimerMilliseconds);
		StartEmwinTimer(m_iTimerMilliseconds);
	}
	else
		m_sEmwinSliderEcho = "Delay: Inf ms";
	
	UpdateData(FALSE);
}
