// LritPlayerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GOESPlayer.h"
#include "GOESPlayerDlg.h"
#include ".\GOESPlayerdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CLritPlayerDlg dialog



CLritPlayerDlg::CLritPlayerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLritPlayerDlg::IDD, pParent)
	, m_sDirectory(_T(""))
	, m_sDirectory2(_T(""))
	, m_iDecimationRate(0)
	, m_dCenterFrequency(137.5e6)
	, m_iBitrate(0)
     , m_iSocket(0)
	, m_dFrequencyOffset(0)
	, m_bEnableAcqEngine(FALSE)
	, m_bUseRecordedData(FALSE)
	, m_bOutputSignalsToFile(FALSE)
	, m_sRecordedDataFile(_T(""))
	, m_sOutputSignalsDir(_T(""))
	, m_bEnableFrontEndFilter(FALSE)
	, m_dPulseRollOff(0)
	, m_iSignalSelect(0)
	, m_bStitchLritImages(FALSE)
	, m_bAnimateEmwinImages(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	for (int i = 0; i < LRIT_IMAGE_LIST_SIZE; i++)
	{
		m_LritImageList[i].bitmap_buffer = NULL;
		m_LritImageList[i].image_height = 0;
		m_LritImageList[i].image_width = 0;
	}

	for (i = 0; i < EMWIN_IMAGE_LIST_SIZE; i++)
		m_EmwinImageList[i].slot_used = FALSE;

//	m_bInitDialog = TRUE;
}

void CLritPlayerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EXTRACTEDFILES, m_ExtractedFiles);
	DDX_Text(pDX, IDC_DIRECTORY, m_sDirectory);
	DDX_Text(pDX, IDC_DIRECTORY2, m_sDirectory2);
	DDX_Control(pDX, IDC_EXTRACTEDFILES2, m_ExtractedFiles2);
	DDX_Text(pDX, IDC_DEC_RATE, m_iDecimationRate);
	DDV_MinMaxByte(pDX, m_iDecimationRate, 4, 254);
	DDX_Text(pDX, IDC_CENTER_FREQ, m_dCenterFrequency);
	DDX_Text(pDX, IDC_BITRATE, m_iBitrate);
	DDV_MinMaxUInt(pDX, m_iBitrate, 1, 4294967295);
	DDX_Text(pDX, IDC_FREQ_OFFSET, m_dFrequencyOffset);
     DDX_Text(pDX, IDC_SOCKET_CONTROL, m_iSocket);
	DDX_Radio(pDX, IDC_ENABLE_ACQ_ENGINE, m_bEnableAcqEngine);
	DDX_Radio(pDX, IDC_USE_REC_DATA, m_bUseRecordedData);
	DDX_Radio(pDX, IDC_OUTPUT_SIG_FILE, m_bOutputSignalsToFile);
	DDX_Text(pDX, IDC_REC_DATA_FILE, m_sRecordedDataFile);
	DDX_Text(pDX, IDC_OUTPUT_SIG_DIR, m_sOutputSignalsDir);
	DDX_Radio(pDX, IDC_ENABLE_FRONT_END_FILTER, m_bEnableFrontEndFilter);
	DDX_Text(pDX, IDC_PULSE_ROLL_OFF, m_dPulseRollOff);
	DDV_MinMaxDouble(pDX, m_dPulseRollOff, 0.0, 1.0);
	DDX_Radio(pDX, IDC_SIGNAL_BPSK, m_iSignalSelect);
	DDX_Check(pDX, IDC_STITCH_LRIT, m_bStitchLritImages);
	DDX_Check(pDX, IDC_ANIMATE_EMWIN, m_bAnimateEmwinImages);
}

BEGIN_MESSAGE_MAP(CLritPlayerDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_LBN_DBLCLK(IDC_EXTRACTEDFILES, OnLbnDblclkExtractedfiles)
	ON_BN_CLICKED(IDC_STOPREALTIME, OnBnClickedStoprealtime)
	ON_BN_CLICKED(IDC_STARTREALTIME, OnBnClickedStartrealtime)
	ON_BN_CLICKED(IDC_STARTREALTIME2, OnBnClickedStartrealtime2)
	ON_BN_CLICKED(IDC_STOPREALTIME2, OnBnClickedStoprealtime2)
	ON_LBN_DBLCLK(IDC_EXTRACTEDFILES2, OnLbnDblclkExtractedfiles2)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_RUN_GNU_RADIO, OnRunGnuRadio)
	ON_BN_CLICKED(IDC_CLEAR_LIST_1, OnBnClickedClearList1)
	ON_BN_CLICKED(IDC_CLEAR_LIST_2, OnBnClickedClearList2)
	ON_BN_CLICKED(IDC_USE_REC_DATA, OnBnClickedUseRecData)
	ON_BN_CLICKED(IDC_DONT_USE_REC_DATA, OnBnClickedDontUseRecData)
	ON_BN_CLICKED(IDC_OUTPUT_SIG_FILE, OnBnClickedOutputSigFile)
	ON_BN_CLICKED(IDC_DONT_OUTPUT_SIG_FILE, OnBnClickedDontOutputSigFile)
	ON_BN_CLICKED(IDC_SIGNAL_BPSK, OnBnClickedSignalBpsk)
	ON_BN_CLICKED(IDC_SIGNAL_FSK, OnBnClickedSignalFsk)
	ON_BN_CLICKED(IDC_SIGNAL_OQPSK, OnBnClickedSignalOqpsk)
END_MESSAGE_MAP()


// CLritPlayerDlg message handlers

BOOL CLritPlayerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	GetDlgItem(IDC_STOPREALTIME)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPREALTIME2)->EnableWindow(FALSE);

	m_sDirectory = "C:\\LRITTEMP";
	m_sDirectory2 = "C:\\EMWINTEMP";

	m_iFileCount = 0;
	m_iFileCount2 = 0;

	m_bStitchLritImages = TRUE;
	m_bAnimateEmwinImages = TRUE;

	m_sDblClickFilename = "";

	m_iDecimationRate = 108;
	m_dCenterFrequency = 137.5e6;
    m_iBitrate = 293883;
     m_iSocket = 0; 
	m_bEnableAcqEngine = FALSE;
	m_bUseRecordedData = TRUE;
	m_bOutputSignalsToFile = TRUE;
	m_sRecordedDataFile = "C:\\Program Files\\HRIT Radio\\LRIT108.txt";
	m_sOutputSignalsDir = "C:\\temp\\usrp_log";
	m_bEnableFrontEndFilter = FALSE;
	m_dPulseRollOff = 0.5;
	m_iSamplesPerSymbol = 2;
	m_iSignalSelect = 0;

	UpdateData(FALSE);

	GetDlgItem(IDC_REC_DATA_FILE)->EnableWindow(FALSE);
	GetDlgItem(IDC_OUTPUT_SIG_DIR)->EnableWindow(FALSE);

	CString tempstr = "";
	WIN32_FIND_DATA data;
	HANDLE handle = FindFirstFile("temp_*.bmp", &data);	
	DeleteFile(data.cFileName);
	while (FindNextFile(handle, &data))
		DeleteFile(data.cFileName);
	FindClose(handle);

	bmpDlg.Create(IDD_BITMAP_DIALOG);
	bmpDlg.SetWindowText("LRIT Image Display");
	bmpDlg.m_bDisplayLrit = TRUE;
	bmpDlg.ShowWindow(SW_HIDE);
	bmpDlg.InitBitmapDisplay();
	bmpDlg.SetDlgItemText(IDC_EMWIN_SPEED_ECHO, "");
	bmpDlg.m_EmwinSlider.ShowWindow(SW_HIDE);

	bmpDlg2.Create(IDD_BITMAP_DIALOG);
	bmpDlg2.SetWindowText("EMWIN Image Display");
	bmpDlg2.m_bDisplayLrit = FALSE;
	bmpDlg2.ShowWindow(SW_HIDE);
	bmpDlg2.InitBitmapDisplay();
	bmpDlg2.m_EmwinImageLoop = &m_EmwinLoopRange;
	bmpDlg2.m_iTimerMilliseconds = EMWIN_LOOP_DEFAULT_DELAY;
	tempstr.Format("Delay: %u ms", EMWIN_LOOP_DEFAULT_DELAY);
	bmpDlg2.SetDlgItemText(IDC_EMWIN_SPEED_ECHO, (LPCTSTR)tempstr);
	bmpDlg2.m_EmwinSlider.SetRange(EMWIN_LOOP_MIN_DELAY, EMWIN_LOOP_MAX_DELAY, TRUE);
	bmpDlg2.m_EmwinSlider.SetPos(EMWIN_LOOP_DEFAULT_DELAY);

	emwTxtDlg.Create(IDD_EMWIN_TEXT_DIALOG);
	emwTxtDlg.ShowWindow(SW_HIDE);

	if (FileExists(m_sDirectory))
	{
		handle = FindFirstFile(m_sDirectory + "\\*.*", &data);		// first call returns "."
		FindNextFile(handle, &data);	// second call returns ".."
		while (FindNextFile(handle, &data))
		{
			m_ExtractedFiles.AddString(data.cFileName);
			m_ExtractedFiles.SetTopIndex(m_iFileCount);
			tempstr = "";
			tempstr.Format("%u", ++m_iFileCount);
			SetDlgItemText(IDC_LRITFILECNT, tempstr);
		}
		FindClose(handle);
	}
	if (FileExists(m_sDirectory2))
	{
		handle = FindFirstFile(m_sDirectory2 + "\\*.*", &data);		// first call returns "."
		FindNextFile(handle, &data);	// second call returns ".."
		while (FindNextFile(handle, &data))
		{
			m_ExtractedFiles2.AddString(data.cFileName);
			m_ExtractedFiles2.SetTopIndex(m_iFileCount2);
			tempstr = "";
			tempstr.Format("%u", ++m_iFileCount2);
			SetDlgItemText(IDC_EMWINFILECNT, tempstr);
		}
		FindClose(handle);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLritPlayerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLritPlayerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLritPlayerDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CLritPlayerDlg::OnLbnDblclkExtractedfiles()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	BYTE *pixel = NULL;
	CString search_string = "";
	CString temp_string = "", temp_string2 = "";
	CImage image;
	UINT stitch_height, stitch_width;
	UINT height_sum;
	UINT start_seg, stop_seg;
	UINT image_seg;
	UINT clicked_seg;
	int i, j, k;

	FreeImageBuffer();

	int index = m_ExtractedFiles.GetCurSel();
	m_ExtractedFiles.GetText(index, m_sDblClickFilename);

	search_string = m_sDblClickFilename.Left(m_sDblClickFilename.Find("seg"));

	temp_string = m_sDblClickFilename;
	temp_string = temp_string.Right(temp_string.GetLength() - search_string.GetLength() - 3);
	temp_string = temp_string.Left(3);
	clicked_seg = atoi((LPCTSTR)temp_string);
	if (!GetLritImageFromFile(m_sDblClickFilename, &m_LritImageList[clicked_seg - 1].bitmap_buffer, m_LritImageList[clicked_seg - 1].image_width, m_LritImageList[clicked_seg - 1].image_height))
	{
		AfxMessageBox("Cannot display LRIT image file " + m_sDblClickFilename + "!", MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	start_seg = stop_seg = clicked_seg;

	if (m_bStitchLritImages)
	{
		for (i = index - 1; i >= 0 && start_seg > 1; i--)
		{
			m_ExtractedFiles.GetText(i, temp_string);		
			if (search_string == temp_string.Left(search_string.GetLength()))
			{
				temp_string2 = temp_string.Right(temp_string.GetLength() - search_string.GetLength() - 3);
				temp_string2 = temp_string2.Left(3);
				image_seg = atoi((LPCTSTR)temp_string2);
				if (image_seg == start_seg - 1)
				{
					if (GetLritImageFromFile(temp_string, &m_LritImageList[image_seg - 1].bitmap_buffer, m_LritImageList[image_seg - 1].image_width, m_LritImageList[image_seg - 1].image_height))
						start_seg--;
					else
						break;
				}
				else
					break; //must be decreasing consecutively
			}
		}

		for (i = index + 1; i < m_ExtractedFiles.GetCount(); i++)
		{
			m_ExtractedFiles.GetText(i, temp_string);
			if (search_string == temp_string.Left(search_string.GetLength()))
			{
				temp_string2 = temp_string.Right(temp_string.GetLength() - search_string.GetLength() - 3);
				temp_string2 = temp_string2.Left(3);
				image_seg = atoi((LPCTSTR)temp_string2);
				if (image_seg == stop_seg + 1)
				{
					if (GetLritImageFromFile(temp_string, &m_LritImageList[image_seg - 1].bitmap_buffer, m_LritImageList[image_seg - 1].image_width, m_LritImageList[image_seg - 1].image_height))
						stop_seg++;
					else
						break;
				}
				else
					break; //must be increasing consecutively
			}
		}
	}

	if(!image.IsNull()) 
		image.Destroy();

	stitch_width = m_LritImageList[start_seg - 1].image_width;
	stitch_height = 0;
	for (i = start_seg - 1; i < stop_seg; i++)
		stitch_height += m_LritImageList[i].image_height;

	image.Create(stitch_width, stitch_height, 24, 0);
	
	height_sum = 0;
	i = start_seg - 1;
	do
	{
		for (j = height_sum; j < height_sum + m_LritImageList[i].image_height; j++)
		{
			for (k = 0; k < stitch_width; k++)
			{
				pixel = (BYTE *)image.GetPixelAddress(k, j);
				*pixel = m_LritImageList[i].bitmap_buffer[(j - height_sum) * stitch_width + k];
				*(pixel + 2) = *(pixel + 1) = *pixel;
			}
		}
		height_sum += m_LritImageList[i++].image_height;
	}
	while (i < stop_seg);

	if (FileExists("temp_lrit.bmp"))
		CFile::Remove("temp_lrit.bmp");
	image.Save("temp_lrit.bmp");
	image.Destroy();

	bmpDlg.m_bInitDialog = FALSE;
	bmpDlg.m_sDblClickFilename = m_sDblClickFilename;
	bmpDlg.m_sTempFilename = "temp_lrit.bmp";
	bmpDlg.m_bmpCtrl.LoadFile("temp_lrit.bmp");
	bmpDlg.ShowWindow(SW_SHOW);
}

BOOL CLritPlayerDlg::GetLritImageFromFile(CString filename, BYTE **bitmap_buffer, UINT &image_width, UINT &image_height)
{
	UINT total_header_bytes;
	BYTE bits_per_pixel;
	CStdioFile bitmap_file;
	BYTE primary_header[16];
	BOOL image_header_found = FALSE;
	BYTE *header_ptr;
	BYTE *headers;
	UINT offset;
	CString filename_path;

	filename_path = m_sDirectory + '\\' + filename;

	if (!bitmap_file.Open((LPCTSTR)filename_path, CFile::modeRead | CFile::typeBinary))
	{
		AfxMessageBox("Error opening LRIT Image file " + filename, MB_OK | MB_ICONEXCLAMATION);	
		return FALSE;
	}

	bitmap_file.Read(primary_header, 16);
	total_header_bytes = (primary_header[4] << 24) + (primary_header[5] << 16) + (primary_header[6] << 8) + primary_header[7];
	total_header_bytes -= 16;
	headers = new BYTE[total_header_bytes];
	if (!headers)
	{
		AfxMessageBox("Error allocating memory to read file headers in " + filename, MB_OK | MB_ICONEXCLAMATION);	
		bitmap_file.Close();
		return FALSE;
	}
	if (bitmap_file.Read(headers, total_header_bytes) < total_header_bytes)
	{
		AfxMessageBox("Error reading file headers in " + filename, MB_OK | MB_ICONEXCLAMATION);	
		bitmap_file.Close();
		return FALSE;		
	}

	header_ptr = headers;
	do
	{
		if ((header_ptr[0] == 1) && (header_ptr[1] == 0) && (header_ptr[2] == 9))		//Image header found
		{
			image_header_found = TRUE;
			bits_per_pixel = header_ptr[3];
			image_width = (header_ptr[4] << 8) + header_ptr[5];
			image_height = (header_ptr[6] << 8) + header_ptr[7];
		}
		else
		{
			offset = (header_ptr[1] << 8) + header_ptr[2];
			header_ptr += offset;
		}
	}
	while (!image_header_found && (header_ptr < headers + total_header_bytes));

	delete [] headers;

	if (!image_header_found)
	{
		AfxMessageBox("No image structure record in " + filename + "!", MB_OK | MB_ICONEXCLAMATION);
		bitmap_file.Close();
		return FALSE;
	}

	*bitmap_buffer = new BYTE[image_width*image_height];
	if (!*bitmap_buffer)
	{
		AfxMessageBox("Error allocating memory to read bitmap data in " + filename, MB_OK | MB_ICONEXCLAMATION);	
		bitmap_file.Close();
		return FALSE;
	}
	if (bitmap_file.Read(*bitmap_buffer, image_width*image_height) < image_width*image_height)
	{
		AfxMessageBox("Error reading bitmap data in " + filename, MB_OK | MB_ICONEXCLAMATION);	
		bitmap_file.Close();
		return FALSE;
	}

	bitmap_file.Close();
	return TRUE;
}


void CLritPlayerDlg::OnBnClickedStoprealtime()
{
	// TODO: Add your control notification handler code here
	CString dummy_filename = m_sDirectory + "\\dummy_file.txt";

	UpdateData(TRUE);

	m_bStopLritFileScan = TRUE;

	//force ReadDirectoryChangesW() to return
	HANDLE dummy_handle = CreateFile(dummy_filename, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	CloseHandle(dummy_handle);
}

void CLritPlayerDlg::OnBnClickedStartrealtime()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_sDirectory == "")
	{
		AfxMessageBox("Enter a directory to scan for LRIT files!", MB_OK | MB_ICONEXCLAMATION);	
		return;
	}

	GetDlgItem(IDC_DIRECTORY)->EnableWindow(FALSE);
	GetDlgItem(IDC_STARTREALTIME)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPREALTIME)->EnableWindow(TRUE);

	THREADSTRUCT *thread_param = NULL;
	thread_param = new THREADSTRUCT;
    thread_param->thisDlg = this;
    AfxBeginThread(ScanForLritFilesThread, thread_param);
}

UINT CLritPlayerDlg::ScanForLritFilesThread(LPVOID param)
{
	HANDLE hDir;
	BYTE *Buffer;
	DWORD BytesReturned;
	DWORD Offset;
	TCHAR szFile[MAX_PATH];
	PFILE_NOTIFY_INFORMATION pNotify;
	int count;
	CString tempstr;

	THREADSTRUCT* ts = (THREADSTRUCT*)param;
	ts->thisDlg->m_bStopLritFileScan = FALSE;

	if (!ts->thisDlg->FileExists(ts->thisDlg->m_sDirectory))
	{
		AfxMessageBox("LRIT file scan directory does not exist!", MB_OK | MB_ICONEXCLAMATION);	
		ts->thisDlg->GetDlgItem(IDC_DIRECTORY)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STARTREALTIME)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STOPREALTIME)->EnableWindow(FALSE);
		delete ts;
		return 0;
	}
/*
	WIN32_FIND_DATA data;
	HANDLE handle = FindFirstFile(ts->thisDlg->m_sDirectory + "\\*.*", &data);		// first call returns "."
	FindNextFile(handle, &data);	// second call returns ".."
	while (FindNextFile(handle, &data))
		DeleteFile(ts->thisDlg->m_sDirectory + "\\" + data.cFileName);
	FindClose(handle);
*/
	Buffer = new BYTE[1000000];
	if (!Buffer)
	{
		AfxMessageBox("Error allocating memory in LRIT file scan thread!", MB_OK | MB_ICONEXCLAMATION);	
		ts->thisDlg->GetDlgItem(IDC_DIRECTORY)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STARTREALTIME)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STOPREALTIME)->EnableWindow(FALSE);
		delete ts;
		return 0;		
	}

	hDir = CreateFile(ts->thisDlg->m_sDirectory, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
	if (hDir == INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("Error getting handle to specified LRIT file directory!", MB_OK | MB_ICONEXCLAMATION);	
		ts->thisDlg->GetDlgItem(IDC_DIRECTORY)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STARTREALTIME)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STOPREALTIME)->EnableWindow(FALSE);
		delete ts;
		delete [] Buffer;
		return 0;		
	}

	while (ReadDirectoryChangesW(hDir, Buffer, 1024, FALSE, FILE_NOTIFY_CHANGE_FILE_NAME, &BytesReturned, NULL, NULL) && !ts->thisDlg->m_bStopLritFileScan)
	{
		Offset = 0;
		do
		{
			pNotify = (PFILE_NOTIFY_INFORMATION) &Buffer[Offset];
			Offset += pNotify->NextEntryOffset;
			count = WideCharToMultiByte(CP_ACP, 0, pNotify->FileName, pNotify->FileNameLength / sizeof(WCHAR), szFile, MAX_PATH - 1, NULL, NULL);
			szFile[count] = TEXT('\0');
			ts->thisDlg->m_ExtractedFiles.AddString(szFile);
			ts->thisDlg->m_ExtractedFiles.SetTopIndex(ts->thisDlg->m_iFileCount);
			tempstr = "";
			tempstr.Format("%u", ++ts->thisDlg->m_iFileCount);
			ts->thisDlg->SetDlgItemText(IDC_LRITFILECNT, tempstr);
		}
		while (pNotify->NextEntryOffset != 0);
	}

	tempstr = ts->thisDlg->m_sDirectory + "\\dummy_file.txt";
	CFile::Remove(tempstr);

	ts->thisDlg->GetDlgItem(IDC_DIRECTORY)->EnableWindow(TRUE);
	ts->thisDlg->GetDlgItem(IDC_STARTREALTIME)->EnableWindow(TRUE);
	ts->thisDlg->GetDlgItem(IDC_STOPREALTIME)->EnableWindow(FALSE);
	delete ts; 
	delete [] Buffer;
	CloseHandle(hDir);

	return 0;
}

void CLritPlayerDlg::OnBnClickedStartrealtime2()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	if (m_sDirectory2 == "")
	{
		AfxMessageBox("Enter a directory to scan for EMWIN files!", MB_OK | MB_ICONEXCLAMATION);	
		return;
	}

	GetDlgItem(IDC_DIRECTORY2)->EnableWindow(FALSE);
	GetDlgItem(IDC_STARTREALTIME2)->EnableWindow(FALSE);
	GetDlgItem(IDC_STOPREALTIME2)->EnableWindow(TRUE);

	THREADSTRUCT *thread_param2 = NULL;
	thread_param2 = new THREADSTRUCT;
    thread_param2->thisDlg = this;
    AfxBeginThread(ScanForEmwinFilesThread, thread_param2);
}

void CLritPlayerDlg::OnBnClickedStoprealtime2()
{
	// TODO: Add your control notification handler code here
	CString dummy_filename = m_sDirectory2 + "\\dummy_file.txt";

	UpdateData(TRUE);

	m_bStopEmwinFileScan = TRUE;

	//force ReadDirectoryChangesW() to return
	HANDLE dummy_handle = CreateFile(dummy_filename, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	CloseHandle(dummy_handle);
}

UINT CLritPlayerDlg::ScanForEmwinFilesThread(LPVOID param)
{
	HANDLE hDir;
	BYTE *Buffer;
	DWORD BytesReturned;
	DWORD Offset;
	TCHAR szFile[MAX_PATH];
	PFILE_NOTIFY_INFORMATION pNotify;
	int count;
	CString tempstr;

	THREADSTRUCT* ts = (THREADSTRUCT*)param;
	ts->thisDlg->m_bStopEmwinFileScan = FALSE;

	if (!ts->thisDlg->FileExists(ts->thisDlg->m_sDirectory2))
	{
		AfxMessageBox("EMWIN file scan directory does not exist!", MB_OK | MB_ICONEXCLAMATION);	
		ts->thisDlg->GetDlgItem(IDC_DIRECTORY2)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STARTREALTIME2)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STOPREALTIME2)->EnableWindow(FALSE);
		delete ts;
		return 0;
	}
/*
	WIN32_FIND_DATA data;
	HANDLE handle = FindFirstFile(ts->thisDlg->m_sDirectory2 + "\\*.*", &data);		// first call returns "."
	FindNextFile(handle, &data);	// second call returns ".."
	while (FindNextFile(handle, &data))
		DeleteFile(ts->thisDlg->m_sDirectory2 + "\\" + data.cFileName);
	FindClose(handle);
*/
	Buffer = new BYTE[1000000];
	if (!Buffer)
	{
		AfxMessageBox("Error allocating memory in EMWIN file scan thread!", MB_OK | MB_ICONEXCLAMATION);	
		ts->thisDlg->GetDlgItem(IDC_DIRECTORY2)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STARTREALTIME2)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STOPREALTIME2)->EnableWindow(FALSE);
		delete ts;
		return 0;		
	}

	hDir = CreateFile(ts->thisDlg->m_sDirectory2, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE|FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL);
	if (hDir == INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("Error getting handle to specified EMWIN file directory!", MB_OK | MB_ICONEXCLAMATION);	
		ts->thisDlg->GetDlgItem(IDC_DIRECTORY2)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STARTREALTIME2)->EnableWindow(TRUE);
		ts->thisDlg->GetDlgItem(IDC_STOPREALTIME2)->EnableWindow(FALSE);
		delete ts;
		delete [] Buffer;
		return 0;		
	}

	while (ReadDirectoryChangesW(hDir, Buffer, 1024, FALSE, FILE_NOTIFY_CHANGE_FILE_NAME, &BytesReturned, NULL, NULL) && !ts->thisDlg->m_bStopEmwinFileScan)
	{
		Offset = 0;
		do
		{
			pNotify = (PFILE_NOTIFY_INFORMATION) &Buffer[Offset];
			Offset += pNotify->NextEntryOffset;
			count = WideCharToMultiByte(CP_ACP, 0, pNotify->FileName, pNotify->FileNameLength / sizeof(WCHAR), szFile, MAX_PATH - 1, NULL, NULL);
			szFile[count] = TEXT('\0');
			ts->thisDlg->m_ExtractedFiles2.AddString(szFile);
			ts->thisDlg->m_ExtractedFiles2.SetTopIndex(ts->thisDlg->m_iFileCount2);
			tempstr = "";
			tempstr.Format("%u", ++ts->thisDlg->m_iFileCount2);
			ts->thisDlg->SetDlgItemText(IDC_EMWINFILECNT, tempstr);
		}
		while (pNotify->NextEntryOffset != 0);
	}
	
	tempstr = ts->thisDlg->m_sDirectory2 + "\\dummy_file.txt";
	CFile::Remove(tempstr);

	ts->thisDlg->GetDlgItem(IDC_DIRECTORY2)->EnableWindow(TRUE);
	ts->thisDlg->GetDlgItem(IDC_STARTREALTIME2)->EnableWindow(TRUE);
	ts->thisDlg->GetDlgItem(IDC_STOPREALTIME2)->EnableWindow(FALSE);
	delete ts; 
	delete [] Buffer;
	CloseHandle(hDir);

	return 0;
}

void CLritPlayerDlg::OnLbnDblclkExtractedfiles2()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CString filename_path = "";
	CString tempstr = "", tempstr2 = "";
	CString searchstr = "";
	CStdioFile tempEmwTxtFile;
	CImage image;
	UINT start_image, stop_image;
	UINT clicked_image;
	UINT image_index;

	int index = m_ExtractedFiles2.GetCurSel();
	m_ExtractedFiles2.GetText(index, m_sDblClickFilename);
	filename_path = m_sDirectory2 + '\\' + m_sDblClickFilename;

	tempstr = m_sDblClickFilename;
	tempstr.MakeUpper();
	if (tempstr.Find(".TXT") > -1)
	{
		emwTxtDlg.m_sFilename = m_sDblClickFilename;
		emwTxtDlg.m_sFilenamePath = filename_path;

		if (!tempEmwTxtFile.Open((LPCTSTR)filename_path, CFile::modeRead | CFile::typeText))
			AfxMessageBox("Error opening EMWIN text file " + m_sDblClickFilename, MB_OK | MB_ICONEXCLAMATION);	
		else
		{
			tempstr = "";
			emwTxtDlg.m_EmwTextList.ResetContent();
			while (tempEmwTxtFile.ReadString(tempstr))
			{
				tempstr.TrimRight();
				emwTxtDlg.m_EmwTextList.AddString((LPCTSTR)tempstr);
			}
			tempEmwTxtFile.Close();
		}

		emwTxtDlg.ShowWindow(SW_SHOW);
	}
	else
	{
		for (int i = 0; i < EMWIN_IMAGE_LIST_SIZE; i++)
			m_EmwinImageList[i].slot_used = FALSE;

		tempstr = m_sDblClickFilename.Right(6);
		tempstr = tempstr.Left(2);
		if ((tempstr.GetAt(0) >= '0') && (tempstr.GetAt(0) <= '9') && (tempstr.GetAt(1) >= '0') && (tempstr.GetAt(1) <= '9'))
		{
			clicked_image = atoi((LPCTSTR)tempstr);
			searchstr = m_sDblClickFilename.Left(m_sDblClickFilename.GetLength() - 6);
		}
		else
		{
			clicked_image = 0;
			searchstr = m_sDblClickFilename.Left(m_sDblClickFilename.GetLength() - 4);
		}

		m_EmwinImageList[clicked_image].slot_used = TRUE;
		m_EmwinImageList[clicked_image].filename = m_sDirectory2 + '\\' + m_sDblClickFilename;

		start_image = stop_image = clicked_image;

		if (m_bAnimateEmwinImages)
		{
			for (int i = index - 1; i >= 0 && start_image >= 0; i--)
			{
				m_ExtractedFiles2.GetText(i, tempstr);
				if (searchstr == tempstr.Left(searchstr.GetLength()))
				{
					tempstr2 = tempstr.Right(6);
					tempstr2 = tempstr2.Left(2);
					if ((tempstr2.GetAt(0) >= '0') && (tempstr2.GetAt(0) <= '9') && (tempstr2.GetAt(1) >= '0') && (tempstr2.GetAt(1) <= '9'))
						image_index = atoi((LPCTSTR)tempstr2);
					else
						image_index = 0;
					
					if (image_index < start_image)
					{
						start_image = image_index;
						m_EmwinImageList[image_index].slot_used = TRUE;
						m_EmwinImageList[image_index].filename = m_sDirectory2 + '\\' + tempstr;
					}
					else
						break; //must be decreasing
				}
			}
			
			for (i = index + 1; i < m_ExtractedFiles2.GetCount(); i++)
			{
				m_ExtractedFiles2.GetText(i, tempstr);
				if (searchstr == tempstr.Left(searchstr.GetLength()))
				{
					tempstr2 = tempstr.Right(6);
					tempstr2 = tempstr2.Left(2);
					if ((tempstr2.GetAt(0) >= '0') && (tempstr2.GetAt(0) <= '9') && (tempstr2.GetAt(1) >= '0') && (tempstr2.GetAt(1) <= '9'))
						image_index = atoi((LPCTSTR)tempstr2);
					else
						image_index = 0;
					
					if (image_index > stop_image)
					{
						stop_image = image_index;
						m_EmwinImageList[image_index].slot_used = TRUE;
						m_EmwinImageList[image_index].filename = m_sDirectory2 + '\\' + tempstr;
					}
					else
						break; //must be increasing
				}
			}
		}

		m_EmwinLoopRange.image_count = 0;
		for (i = start_image; i <= stop_image; i++)
		{
			if (m_EmwinImageList[i].slot_used)
			{
				if (i == clicked_image)
					m_EmwinLoopRange.counter = m_EmwinLoopRange.image_count;

				tempstr = "";
				tempstr.Format("temp_emwin_%u.bmp", m_EmwinLoopRange.image_count++); 
				
				if(!image.IsNull()) 
					image.Destroy();
				image.Load((LPCTSTR)m_EmwinImageList[i].filename);
				if (FileExists(tempstr))
					CFile::Remove(tempstr);
				image.Save((LPCTSTR)tempstr);
				image.Destroy();
			}
		}

		tempstr = "";
		tempstr.Format("temp_emwin_%u.bmp", m_EmwinLoopRange.counter); 
		bmpDlg2.m_bInitDialog = FALSE;
		bmpDlg2.m_sDblClickFilename = m_sDblClickFilename;
		bmpDlg2.m_sTempFilename = tempstr;
		bmpDlg2.m_bmpCtrl.LoadFile(tempstr);

		if (m_bAnimateEmwinImages)
		{
			bmpDlg2.StopEmwinTimer();

			tempstr = "";
			if (bmpDlg2.m_iTimerMilliseconds < EMWIN_LOOP_MAX_DELAY)
			{
				tempstr.Format("Delay: %u ms", bmpDlg2.m_iTimerMilliseconds);
				bmpDlg2.StartEmwinTimer(bmpDlg2.m_iTimerMilliseconds);
			}
			else
				tempstr = "Delay: Inf ms";

			bmpDlg2.SetDlgItemText(IDC_EMWIN_SPEED_ECHO, (LPCTSTR)tempstr);
			bmpDlg2.m_EmwinSlider.ShowWindow(SW_SHOW);
		}
		else
		{
			bmpDlg2.SetDlgItemText(IDC_EMWIN_SPEED_ECHO, "");
			bmpDlg2.m_EmwinSlider.ShowWindow(SW_HIDE);
		}

		bmpDlg2.ShowWindow(SW_SHOW);
	}
}

void CLritPlayerDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	WIN32_FIND_DATA data;
	HANDLE handle = FindFirstFile("temp_*.bmp", &data);	
	DeleteFile(data.cFileName);
	while (FindNextFile(handle, &data))
		DeleteFile(data.cFileName);
	FindClose(handle);

	if (bmpDlg.GetSafeHwnd() != 0) 
		bmpDlg.DestroyWindow();
	if (bmpDlg2.GetSafeHwnd() != 0) 
		bmpDlg2.DestroyWindow();
	if (emwTxtDlg.GetSafeHwnd() != 0)
		emwTxtDlg.DestroyWindow();

	FreeImageBuffer();

	OnOK();
}

void CLritPlayerDlg::FreeImageBuffer()
{
	for (int i = 0; i < LRIT_IMAGE_LIST_SIZE; i++)
	{
		if (m_LritImageList[i].bitmap_buffer != NULL)
		{
			delete [] m_LritImageList[i].bitmap_buffer;
			m_LritImageList[i].bitmap_buffer = NULL;
		}
		m_LritImageList[i].image_height = 0;
		m_LritImageList[i].image_width = 0;
	}
}

void CLritPlayerDlg::OnRunGnuRadio()
{
	// TODO: Add your control notification handler code here
	if (!UpdateData(TRUE))
		return;

	THREADSTRUCT *thread_param = NULL;
	thread_param = new THREADSTRUCT;
    thread_param->thisDlg = this;
    AfxBeginThread(RunGnuRadioThread, thread_param);
}

UINT CLritPlayerDlg::RunGnuRadioThread(LPVOID param)
{
	THREADSTRUCT* ts = (THREADSTRUCT*)param;

	ts->thisDlg->GetDlgItem(IDC_RUN_GNU_RADIO)->EnableWindow(FALSE);

    STARTUPINFO si;
    PROCESS_INFORMATION pi;
    ZeroMemory( &si, sizeof(si) );
    si.cb = sizeof(si);
    ZeroMemory( &pi, sizeof(pi) );

	CString command = "";
	CString tempstr = "";

	if (ts->thisDlg->m_iDecimationRate % 2 == 1)
	{
		AfxMessageBox("Decimation rate must be an even number!", MB_OK | MB_ICONEXCLAMATION);
		ts->thisDlg->GetDlgItem(IDC_RUN_GNU_RADIO)->EnableWindow(TRUE);
		delete ts;
		return 0;
	}

     //EV
	//command.Format("Telemetry.exe %u %u %u %lf %lf ", ts->thisDlg->m_iDecimationRate, ts->thisDlg->m_iBitrate, ts->thisDlg->m_iBufferSize,
	//	                                              ts->thisDlg->m_dCenterFrequency, ts->thisDlg->m_dFrequencyOffset);

     command.Format("-dr %u -br %u -fc %lf -foff %lf -socket %u", 
          ts->thisDlg->m_iDecimationRate, 
          ts->thisDlg->m_iBitrate, 
          ts->thisDlg->m_dCenterFrequency, 
          ts->thisDlg->m_dFrequencyOffset,
          ts->thisDlg->m_iSocket);

	if (!ts->thisDlg->m_bUseRecordedData)	
	{
		if (!ts->thisDlg->FileExists(ts->thisDlg->m_sRecordedDataFile))
		{
			AfxMessageBox("Recorded data file does not exist!", MB_OK | MB_ICONEXCLAMATION);
			ts->thisDlg->GetDlgItem(IDC_RUN_GNU_RADIO)->EnableWindow(TRUE);
			delete ts;
			return 0;
		}

		//EV command = command + "1 " + ts->thisDlg->m_sRecordedDataFile + " ";

          command = command + " -rec \"" + ts->thisDlg->m_sRecordedDataFile + "\" ";

	}
     else{
		// EV command = command + "0 dummyfile ";

     }

	if (!ts->thisDlg->m_bOutputSignalsToFile)	
	{
		if (!ts->thisDlg->FileExists(ts->thisDlg->m_sOutputSignalsDir))
		{
			AfxMessageBox("Output signals directory does not exist!", MB_OK | MB_ICONEXCLAMATION);
			ts->thisDlg->GetDlgItem(IDC_RUN_GNU_RADIO)->EnableWindow(TRUE);
			delete ts;
			return 0;
		}

		//EV  command = command + "1 " + ts->thisDlg->m_sOutputSignalsDir + " ";
           command = command + "-wr 1 " ;
	}
     else{
		//EV command = command + "0 dummydirectory ";
     }

     if (!ts->thisDlg->m_bEnableAcqEngine){		
          command += "-acq 1 ";
     }else{
		command += "-acq 0 ";
     }

	if ((ts->thisDlg->m_iSignalSelect == 0) || (ts->thisDlg->m_iSignalSelect == 2))
	{
		tempstr.Format("-roll %lf", ts->thisDlg->m_dPulseRollOff);
		// command = command +  "-samples " +  ts->thisDlg->m_iSymbolsPerSymbol + " ";
          command += tempstr;
		if (!ts->thisDlg->m_bEnableFrontEndFilter)
			command += " -lfilter 1";
		else
			command += " -lfilter 0";

		if (ts->thisDlg->m_iSignalSelect == 0)
			command = "EMWINHRIT.exe " + command;	//LRIT
		else
			command = "EMWINN.exe " + command;	//EMWIN-OQPSK
	}
	else	
	{
		command = "EMWINI.exe " + command;	//EMWIN-FSK
	}

	if (!CreateProcess(NULL, command.GetBuffer(), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi))
    {
        AfxMessageBox("Failed to create GNU Radio process", MB_OK | MB_ICONEXCLAMATION);
		command.ReleaseBuffer();
		ts->thisDlg->GetDlgItem(IDC_RUN_GNU_RADIO)->EnableWindow(TRUE);
		delete ts;
        return 0;
    }
	command.ReleaseBuffer();

	WaitForSingleObject(pi.hProcess, INFINITE);
	
	CloseHandle(pi.hProcess);
    CloseHandle(pi.hThread);

	ts->thisDlg->GetDlgItem(IDC_RUN_GNU_RADIO)->EnableWindow(TRUE);

	delete ts;

	return 0;
}

void CLritPlayerDlg::OnBnClickedClearList1()
{
	// TODO: Add your control notification handler code here
	m_ExtractedFiles.ResetContent();
	m_iFileCount = 0;
	SetDlgItemText(IDC_LRITFILECNT, "0");
}

void CLritPlayerDlg::OnBnClickedClearList2()
{
	// TODO: Add your control notification handler code here
	m_ExtractedFiles2.ResetContent();
	m_iFileCount2 = 0;
	SetDlgItemText(IDC_EMWINFILECNT, "0");
}

BOOL CLritPlayerDlg::FileExists(CString Infilename)
{
	CFileFind FileFinder;

	CString m_sTempstr = Infilename;

	m_sTempstr.MakeLower();
	if (FileFinder.FindFile(m_sTempstr, 0))
		return TRUE;
	else 
	{
		m_sTempstr.MakeUpper();
		if (FileFinder.FindFile(m_sTempstr, 0))
		    return TRUE;
	    else
		    return FALSE;
	} 
}

void CLritPlayerDlg::OnBnClickedUseRecData()
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_REC_DATA_FILE)->EnableWindow(TRUE);
}

void CLritPlayerDlg::OnBnClickedDontUseRecData()
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_REC_DATA_FILE)->EnableWindow(FALSE);
}

void CLritPlayerDlg::OnBnClickedOutputSigFile()
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_OUTPUT_SIG_DIR)->EnableWindow(TRUE);
}

void CLritPlayerDlg::OnBnClickedDontOutputSigFile()
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_OUTPUT_SIG_DIR)->EnableWindow(FALSE);
}

void CLritPlayerDlg::OnBnClickedSignalBpsk()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	GetDlgItem(IDC_PULSE_ROLL_OFF)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENABLE_FRONT_END_FILTER)->EnableWindow(TRUE);
	GetDlgItem(IDC_DISABLE_FRONT_END_FILTER)->EnableWindow(TRUE);

	m_iDecimationRate = 108;
	m_dCenterFrequency = 137.5e6;
     m_iBitrate = 293883;
    	m_sRecordedDataFile = "C:\\Program Files\\HRIT Radio\\LRIT108.txt";
	UpdateData(FALSE);
}

void CLritPlayerDlg::OnBnClickedSignalFsk()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	GetDlgItem(IDC_PULSE_ROLL_OFF)->EnableWindow(FALSE);
	GetDlgItem(IDC_ENABLE_FRONT_END_FILTER)->EnableWindow(FALSE);
	GetDlgItem(IDC_DISABLE_FRONT_END_FILTER)->EnableWindow(FALSE);

	m_iDecimationRate = 66;
	m_dCenterFrequency = 137.225e6;
    m_iBitrate = 9600;
    	m_sRecordedDataFile = "C:\\Program Files\\HRIT Radio\\fsk66.txt";
	UpdateData(FALSE);
}

void CLritPlayerDlg::OnBnClickedSignalOqpsk()
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	GetDlgItem(IDC_PULSE_ROLL_OFF)->EnableWindow(TRUE);
	GetDlgItem(IDC_ENABLE_FRONT_END_FILTER)->EnableWindow(TRUE);
	GetDlgItem(IDC_DISABLE_FRONT_END_FILTER)->EnableWindow(TRUE);

	m_iDecimationRate = 254;
	m_dCenterFrequency = 137.9e6;
    m_iBitrate = 17970;
    m_sRecordedDataFile = "C:\\Program Files\\HRIT Radio\\EMWIN254.txt";
	UpdateData(FALSE);
}