// LritPlayerDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "BitmapCtrl.h"
#include "EmwinTextDlg.h"
#include "BitmapDlg.h"
#include "HScrollListBox.h"

#define LRIT_IMAGE_LIST_SIZE 1000
#define EMWIN_IMAGE_LIST_SIZE 100

typedef struct LRITIMAGESTRUCT
{
	BYTE *bitmap_buffer;
	UINT image_height;
	UINT image_width;
} LRITIMAGESTRUCT;

typedef struct EMWINIMAGESTRUCT
{
	BOOL slot_used;
	CString filename;
} EMWINIMAGESTRUCT;

// CLritPlayerDlg dialog
class CLritPlayerDlg : public CDialog
{
// Construction
public:
	CLritPlayerDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_LRITPLAYER_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;
	CBitmapCtrl m_bmpCtrl;
	BOOL m_bStopLritFileScan;
	BOOL m_bStopEmwinFileScan;
	UINT m_iFileCount;
	UINT m_iFileCount2;
	CEmwinTextDlg emwTxtDlg;
	CBitmapDlg bmpDlg;
	CBitmapDlg bmpDlg2;
	CString m_sDblClickFilename;
	LRITIMAGESTRUCT m_LritImageList[LRIT_IMAGE_LIST_SIZE];
	EMWINIMAGESTRUCT m_EmwinImageList[EMWIN_IMAGE_LIST_SIZE];
	EMWINLOOPSTRUCT m_EmwinLoopRange;

	static UINT ScanForLritFilesThread(LPVOID param);
	static UINT ScanForEmwinFilesThread(LPVOID param);
	static UINT RunGnuRadioThread(LPVOID param);
	BOOL FileExists(CString Infilename);
	void FreeImageBuffer();
	BOOL CLritPlayerDlg::GetLritImageFromFile(CString filename, BYTE **bitmap_buffer, UINT &image_width, UINT &image_length);

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	afx_msg void OnBnClickedStoprealtime();
	afx_msg void OnBnClickedStoprealtime2();
	afx_msg void OnBnClickedStartrealtime();
	afx_msg void OnBnClickedStartrealtime2();
	afx_msg void OnLbnDblclkExtractedfiles();
	afx_msg void OnLbnDblclkExtractedfiles2();
	afx_msg void OnBnClickedOk();
	afx_msg void OnRunGnuRadio();
	afx_msg void OnBnClickedClearList1();
	afx_msg void OnBnClickedClearList2();
	afx_msg void OnBnClickedUseRecData();
	afx_msg void OnBnClickedDontUseRecData();
	afx_msg void OnBnClickedOutputSigFile();
	afx_msg void OnBnClickedDontOutputSigFile();
	afx_msg void OnBnClickedSignalBpsk();
	afx_msg void OnBnClickedSignalFsk();
	afx_msg void OnBnClickedSignalOqpsk();

	CHScrollListBox m_ExtractedFiles;
	CHScrollListBox m_ExtractedFiles2;
	CString m_sDirectory;
	CString m_sDirectory2;
	BYTE m_iDecimationRate;
	double m_dCenterFrequency;
	UINT m_iBitrate;
     UINT m_iSocket;
	double m_dFrequencyOffset;
	BOOL m_bEnableAcqEngine;
	BOOL m_bUseRecordedData;
	BOOL m_bOutputSignalsToFile;
	CString m_sRecordedDataFile;
	CString m_sOutputSignalsDir;
	BOOL m_bEnableFrontEndFilter;
	double m_dPulseRollOff;
	int m_iSignalSelect;
	UINT m_iSamplesPerSymbol;
	BOOL m_bStitchLritImages;
	BOOL m_bAnimateEmwinImages;
};

typedef struct THREADSTRUCT
{
    CLritPlayerDlg*	thisDlg;
} THREADSTRUCT;
