
#ifndef INCLUDED_ar_conv_encoder_H
#define	INCLUDED_ar_conv_encoder_H

#include <gr_sync_decimator.h>
#include <ipp.h>

class ar_conv_encoder;
typedef boost::shared_ptr<ar_conv_encoder> ar_conv_encoder_sptr;

ar_conv_encoder_sptr  ar_make_conv_encoder (int modulation);
ar_conv_encoder_sptr  ar_make_conv_encoder ();


class ar_conv_encoder : public gr_block
{
 private:
  friend ar_conv_encoder_sptr  ar_make_conv_encoder (int modulation);
  friend ar_conv_encoder_sptr  ar_make_conv_encoder ();
  int d_modulation;
  
  ar_conv_encoder(int modulation);

 public:
  ~ar_conv_encoder();
  
  void forecast(int noutput_items, gr_vector_int &ninput_items_required);
  
  int general_work (int noutput_items,
		    gr_vector_int &ninput_items,
		    gr_vector_const_void_star &input_items,
		    gr_vector_void_star &output_items);
};

#endif
