#ifndef INCLUDED_GR_FRACTIONAL_INTERPOLATOR_CC_H
#define	INCLUDED_GR_FRACTIONAL_INTERPOLATOR_CC_H

#include <gr_block.h>

class ari_mmse_fir_interpolator_cc;

class ar_fractional_interpolator_cc;
typedef boost::shared_ptr<ar_fractional_interpolator_cc> ar_fractional_interpolator_cc_sptr;

// public constructor
ar_fractional_interpolator_cc_sptr ar_make_fractional_interpolator_cc (float phase_shift, float interp_ratio);

/*!
 * \brief Interpolating mmse filter with gr_complex input, gr_complex output
 * \ingroup filter
 */
class ar_fractional_interpolator_cc : public gr_block
{
public:
  ~ar_fractional_interpolator_cc ();
  void forecast(int noutput_items, gr_vector_int &ninput_items_required);
  int general_work (int noutput_items,
		    gr_vector_int &ninput_items,
		    gr_vector_const_void_star &input_items,
		    gr_vector_void_star &output_items);

  float mu() const { return d_mu;}
  float interp_ratio() const { return d_mu_inc;}
  void set_mu (float mu) { d_mu = mu; }
  void set_interp_ratio (float interp_ratio) { d_mu_inc = interp_ratio; }

protected:
  ar_fractional_interpolator_cc (float phase_shift, float interp_ratio);

private:
  float 			d_mu;
  float 			d_mu_inc;
  // gri_mmse_fir_interpolator_cc 	*d_interp;
  // EV
  ari_mmse_fir_interpolator_cc 	*d_interp;

  friend ar_fractional_interpolator_cc_sptr
  ar_make_fractional_interpolator_cc (float phase_shift, float interp_ratio);
};

#endif
