
#ifndef INCLUDED_GR_integrate_dump_cc_H
#define	INCLUDED_GR_integrate_dump_cc_H

#include <gr_sync_decimator.h>
#include <ipp.h>

class gr_integrate_dump_cc;
typedef boost::shared_ptr<gr_integrate_dump_cc> gr_integrate_dump_cc_sptr;
gr_integrate_dump_cc_sptr gr_make_integrate_dump_cc (int samples_per_symbol);


/*!
 * Simple integrate and dump block
 */
class gr_integrate_dump_cc : public gr_sync_decimator
{
 private:
  friend gr_integrate_dump_cc_sptr gr_make_integrate_dump_cc (int samples_per_symbol);
  float d_mean_pwr;
  float d_pwr_alpha;
  int d_samples_per_symbol;

  gr_integrate_dump_cc(int samples_per_symbol);
 public:

  int work (int noutput_items,
		 gr_vector_const_void_star &input_items,
		 gr_vector_void_star &output_items);

  //! Returns the mean value of the integrated samples. Mean is computed
  //! as an IIR filter: mean[k] = (1-alpha) *mean[k-1]+alpha*integrated[k]
  float get_mean_pwr() {return d_mean_pwr;}
  //! Set the averaging constant
  void  set_pwr_alpha(float pwr_alpha) {d_pwr_alpha = pwr_alpha;}
};

#endif
