
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <ar_short_to_uchar.h>
#include <gr_io_signature.h>
#include <ari_short_to_uchar.h>

gr_short_to_uchar_sptr
gr_make_short_to_uchar ()
{
  return gr_short_to_uchar_sptr (new gr_short_to_uchar ());
}

gr_short_to_uchar::gr_short_to_uchar ()
  : gr_sync_block ("gr_short_to_uchar",
		   gr_make_io_signature (1, 1, sizeof (short)),
		   gr_make_io_signature (1, 1, sizeof (unsigned char)))
{
}

int
gr_short_to_uchar::work (int noutput_items,
			 gr_vector_const_void_star &input_items,
			 gr_vector_void_star &output_items)
{
  const short *in = (const short *) input_items[0];
  unsigned char *out = (unsigned char *) output_items[0];

  gri_short_to_uchar (in, out, noutput_items);
  
  return noutput_items;
}



