
#ifndef   INCLUDED_GR_viterbi_H
#define	INCLUDED_GR_viterbi_H

#include <gr_hier_block2.h>

#include <gr_sync_decimator.h>
#include <ipp.h>

class gr_viterbi;
typedef boost::shared_ptr<gr_viterbi> gr_viterbi_sptr;

gr_viterbi_sptr  gr_make_viterbi(int modulation, int resynch_period, float AGC, float vthresh);
gr_viterbi_sptr  gr_make_viterbi (int modulation);
gr_viterbi_sptr  gr_make_viterbi ();


class gr_viterbi : public gr_block
//class gr_viterbi : public gr_hier_block2  //Can't do this. No "consume_each"

{
 private:
  friend gr_viterbi_sptr  gr_make_viterbi(int modulation, int resynch_period);
  friend gr_viterbi_sptr  gr_make_viterbi (int modulation);
  friend gr_viterbi_sptr  gr_make_viterbi(int modulation, int resynch_period, float AGC, float vthresh);
  friend gr_viterbi_sptr  gr_make_viterbi ();
  int d_modulation;
  int d_resynch_period;
  float d_AGC;
  float d_vthresh;
  
  gr_viterbi(int modulation, int resynch_period, float AGC, float vthresh);

 public:
  ~gr_viterbi();
  
  void forecast(int noutput_items, gr_vector_int &ninput_items_required);
  
  int general_work (int noutput_items,
		    gr_vector_int &ninput_items,
		    gr_vector_const_void_star &input_items,
		    gr_vector_void_star &output_items);
};

#endif
