#include "gnuradio_misc.h"
#include <gr_block.h>
#include <fstream>
#include <iterator>
#include <assert.h>

void dump(const vector<float> &data, const string &filename)
{
  ofstream file(filename.c_str());
  copy (data.begin(), data.end(), ostream_iterator<float>(file," "));
}

void grab(vector<float> &data, const string &filename)
{
  ifstream file(filename.c_str());
  assert(file.is_open());
  copy(istream_iterator<float>(file),
       istream_iterator<float>(),
       inserter(data, data.begin()));
}

gr_block_sptr find_block(const vector<gr_block_sptr> &blocks,
                         const std::string name)
{
    gr_block_sptr result;

    for (vector<gr_block_sptr>::const_iterator b=blocks.begin(); b<blocks.end(); ++b)
        if ((*b)->name() == name) {result = (*b); break;}

    if (!result)
    {
        printf("Could not find block : %s\n", name.c_str());
        assert(0);
    }


    return result;    
}



