#ifndef INCLUDED_TCP_DEBUG_SERVER_H
#define INCLUDED_TCP_DEBUG_SERVER_H

class tcp_debug_sink;

//! Register a tcp_debug_sink with the main tcp_debug_server.
//  The first call to this function also initializes the server and
//  starts listening for incoming TCP/IP connections.
void tcp_debug_server_register(const char* name, size_t itemsize, int typecode, tcp_debug_sink* tds);

//! Un-register the given tcp_debug_sink.  (i.e. when it is closed).
//  When the last sink is unregistered, the tcp_debug_server is shut down.
void tcp_debug_server_unregister(tcp_debug_sink* tds);

#endif /* INCLUDED_TCP_DEBUG_SERVER_H */
