//-----------------------------
//   AERO-RADIO
//        improving gnuradio!
//-----------------------------

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <ar_binary_diffslicer_fb.h>
#include <gr_io_signature.h>
#include <stdexcept>

ar_binary_diffslicer_fb_sptr
ar_make_binary_diffslicer_fb ()
{
  return ar_binary_diffslicer_fb_sptr (new ar_binary_diffslicer_fb ());
}

ar_binary_diffslicer_fb::ar_binary_diffslicer_fb ()
  : gr_sync_block ("binary_diffslicer_fb",
		   gr_make_io_signature (1, 1, sizeof (float)),
		   gr_make_io_signature (1, 1, sizeof (unsigned char)))
{
}

static inline int
slice(float x)
{
  return x < 0 ? 0 : 1;
}

static inline int
diffslice(float x,float y)
{
  bool p,q;
  x < 0 ? p=0 : p=1;
  y < 0 ? q=0 : q=1;

  return  (p || q) && !(p && q) ; 

}


int
ar_binary_diffslicer_fb::work (int noutput_items,
			   gr_vector_const_void_star &input_items,
			   gr_vector_void_star &output_items)
{
  const float *in = (const float *) input_items[0];
  unsigned char *out = (unsigned char *) output_items[0];

  //EV
  // I return one less than the number of outputs used
  // so that the next time I call this block
  out[0] = slice(in[0]);
  for (int i = 1; i < noutput_items; i++){
    // out[i] = slice(in[i]);
       out[i] = diffslice(in[i-1],in[i]);

  }
  
  return (noutput_items-1);
}
