
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <ar_float_to_complex.h>
#include <gr_io_signature.h>
#include <ipp.h>


gr_float_to_complex_sptr
gr_make_float_to_complex ()
{
  return gr_float_to_complex_sptr (new gr_float_to_complex ());
}

gr_float_to_complex::gr_float_to_complex ()
  : gr_sync_block ("gr_float_to_complex",
		   gr_make_io_signature (1, 2, sizeof (float)),
		   gr_make_io_signature (1, 1, sizeof (gr_complex)))
{
}

int
gr_float_to_complex::work (int noutput_items,
			   gr_vector_const_void_star &input_items,
			   gr_vector_void_star &output_items)
{
  float	*r = (float *)input_items[0];
  float   *i = (float *)input_items[1];
  gr_complex *out = (gr_complex *) output_items[0];

  switch (input_items.size ()){
  case 1:
    for (int j = 0; j < noutput_items; j++)
      out[j] = gr_complex (r[j], 0);
    break;

  case 2:
     ippsRealToCplx_32f( (Ipp32f*)r, (Ipp32f*)i,(Ipp32fc*)out,  noutput_items);
    
    //for (int j = 0; j < noutput_items; j++)
    //  out[j] = gr_complex (r[j], i[j]);

    
    break;

  default:
    assert (0);
  }

  return noutput_items;
}



