
#ifndef INCLUDED_GR_FLOAT_TO_COMPLEX_H
#define INCLUDED_GR_FLOAT_TO_COMPLEX_H

#include <gr_sync_block.h>
#include <gr_complex.h>

class gr_float_to_complex;
typedef boost::shared_ptr<gr_float_to_complex> gr_float_to_complex_sptr;

gr_float_to_complex_sptr
gr_make_float_to_complex ();

/*!
 * \brief Convert 1 or 2 streams of float to a stream of gr_complex
 * \ingroup converter
 */

class gr_float_to_complex : public gr_sync_block
{
  friend gr_float_to_complex_sptr gr_make_float_to_complex ();
  gr_float_to_complex ();

 public:
  virtual int work (int noutput_items,
		    gr_vector_const_void_star &input_items,
		    gr_vector_void_star &output_items);
};


#endif /* INCLUDED_GR_FLOAT_TO_COMPLEX_H */
